﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Telerik.Windows.Controls;
using Telerik.Windows.Controls.ScheduleView;

namespace ResourceTypeDynamicTest
{
    public class MainViewModel : ViewModelBase
    {
        public MainViewModel()
        {
            MakeAppointments();
        }

        private void MakeAppointments()
        {
            //load resources
            var rt = new ResourceType("Location");
            rt.Resources.Add(new Resource("Hall A"));
            rt.Resources.Add(new Resource("Hall B"));
            rt.Resources.Add(new Resource("Hall C"));
            this.ResourceTypes.Add(rt);


            //create sample appointments
            for (int i = 0; i < 20; i++)
            {
                //new-up an Appointment object
                var app = new Appointment()
                {
                    Subject = "Appointment " + i.ToString(),
                    Start = DateTime.Now.AddHours(i),
                    End = DateTime.Now.AddHours(i).AddMinutes(30)
                };

                //add the Resource to the appointment (be sure to add the ResourceType here)
                if(i%2==0)
                {
                    app.Resources.Add(new Resource("Hall A", "Location"));
                }
                else
                {
                    app.Resources.Add(new Resource("Hall B", "Location"));
                }

                app.Resources.Add(new Resource("Hall C", "Location"));

                //add the appointment to the ScheduleView
                this.Appointments.Add(app);
            }
        }

        private ObservableCollection<Appointment> appointments = new ObservableCollection<Appointment>();
        public ObservableCollection<Appointment> Appointments
        {
            get { return appointments; }
            set
            {
                appointments = value; 
                OnPropertyChanged("Appointments");
            }
        }

        private ObservableCollection<ResourceType> reourceTypes = new ObservableCollection<ResourceType>();
        public ObservableCollection<ResourceType> ResourceTypes
        {
            get { return reourceTypes; }
            set
            {
                reourceTypes = value; 
                OnPropertyChanged("ResourceTypes");
            }
        }

    }
}
